/* 
 * Copyright (c) 1995 The University of Utah and
 * the Computer Systems Laboratory at the University of Utah (CSL).
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software is hereby
 * granted provided that (1) source code retains these copyright, permission,
 * and disclaimer notices, and (2) redistributions including binaries
 * reproduce the notices in supporting documentation, and (3) all advertising
 * materials mentioning features or use of this software display the following
 * acknowledgement: ``This product includes software developed by the
 * Computer Systems Laboratory at the University of Utah.''
 *
 * THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
 * IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 *
 *      Author: Bryan Ford, University of Utah CSL
 */
#ifndef _MACH_SA_ERRNO_H_
#define _MACH_SA_ERRNO_H_

extern int errno;			/* global error number */

/* POSIX-defined errors */
#define	E2BIG		0xc001		/* Argument list too long */
#define	EACCES		0xc002		/* Permission denied */
#define	EAGAIN		0xc003		/* Resource temporarily unavailable */
#define	EBADF		0xc004		/* Bad file descriptor */
#define	EBUSY		0xc005		/* Device busy */
#define	ECHILD		0xc006		/* No child processes */
#define	EDEADLK		0xc007		/* Resource deadlock avoided */
#define	EDOM		0xc008		/* Numerical argument out of domain */
#define	EEXIST		0xc009		/* File exists */
#define	EFAULT		0xc00a		/* Bad address */
#define	EFBIG		0xc00b		/* File too large */
#define	EINTR		0xc00c		/* Interrupted system call */
#define	EINVAL		0xc00d		/* Invalid argument */
#define	EIO		0xc00e		/* Input/output error */
#define	EISDIR		0xc01f		/* Is a directory */
#define	EMFILE		0xc010		/* Too many open files */
#define	EMLINK		0xc011		/* Too many links */
#define	ENAMETOOLONG	0xc012		/* File name too long */
#define	ENFILE		0xc013		/* Too many open files in system */
#define	ENODEV		0xc014		/* Operation not supported by device */
#define	ENOENT		0xc015		/* No such file or directory */
#define	ENOEXEC		0xc017		/* Exec format error */
#define	ENOLCK		0xc018		/* No locks available */
#define	ENOMEM		0xc019		/* Cannot allocate memory */
#define	ENOSPC		0xc01a		/* No space left on device */
#define	ENOSYS		0xc01b		/* Function not implemented */
#define	ENOTDIR		0xc01c		/* Not a directory */
#define	ENOTEMPTY	0xc01d		/* Directory not empty */
#define	ENOTTY		0xc01e		/* Inappropriate ioctl for device */
#define	ENXIO		0xc01f		/* Device not configured */
#define	EPERM		0xc020		/* Operation not permitted */
#define	EPIPE		0xc021		/* Broken pipe */
#define	ERANGE		0xc022		/* Result too large */
#define	EROFS		0xc023		/* Read-only file system */
#define	ESPIPE		0xc024		/* Illegal seek */
#define	ESRCH		0xc025		/* No such process */
#define	EXDEV		0xc026		/* Cross-device link */

#endif _MACH_SA_ERRNO_H_
