/* 
 * Copyright (c) 1990, 1991, 1992, 1994, The University of Utah and
 * the Computer Systems Laboratory at the University of Utah (CSL).
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software is hereby
 * granted provided that (1) source code retains these copyright, permission,
 * and disclaimer notices, and (2) redistributions including binaries
 * reproduce the notices in supporting documentation, and (3) all advertising
 * materials mentioning features or use of this software display the following
 * acknowledgement: ``This product includes software developed by the
 * Computer Systems Laboratory at the University of Utah.''
 *
 * THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
 * IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 *
 * 	Utah $Hdr: exception.h 1.8 94/12/14$
 */

#ifndef	_MACH_PARISC_EXCEPTION_H_
#define _MACH_PARISC_EXCEPTION_H_

/*
 *	EXC_BAD_INSTRUCTION
 */

#define EXC_PARISC_INVALID_SYSCALL	1    /* invalid syscall number */
#define EXC_PARISC_UNIPL_INST		2    /* unimplemented instruction */
#define EXC_PARISC_PRIVINST		3    /* priviledged instruction */
#define EXC_PARISC_PRIVREG		4    /* priviledged register */

/*
 *	EXC_BAD_ACCESS
 *	Note: do not conflict with kern_return_t values returned by vm_fault
 */

#define EXC_PARISC_VM_PROT_READ		0x101 /* error reading syscall args */
#define EXC_PARISC_BADSPACE		0x102 /* bad space referenced */
#define EXC_PARISC_UNALIGNED		0x103 /* unaligned data reference */

/*
 *	EXC_ARITHMETIC
 */

#define EXC_PARISC_OVERFLOW		1    /* integer overflow */
#define EXC_PARISC_ZERO_DIVIDE		2    /* integer divide by zero */
#define EXC_PARISC_FLT_INEXACT		3    /* IEEE inexact exception */
#define EXC_PARISC_FLT_ZERO_DIVIDE	4    /* IEEE zero divide */
#define EXC_PARISC_FLT_UNDERFLOW	5    /* IEEE floating underflow */
#define EXC_PARISC_FLT_OVERFLOW		6    /* IEEE floating overflow */
#define EXC_PARISC_FLT_NOT_A_NUMBER	7    /* IEEE not a number */

	/*
	 * EXC_PARISC_NOEMULATION should go away when we add software emulation
	 * for floating point. Right now we don't support this.
	 */

#define EXC_PARISC_NOEMULATION		8    /* no floating point emulation */


/*
 *	EXC_SOFTWARE
 */
#define EXC_PARISC_MIGRATE		0x10100		/* Time to bolt */


/*
 *	EXC_BREAKPOINT
 */

#define EXC_PARISC_BREAKPOINT		1    /* breakpoint trap */
#define EXC_PARISC_TAKENBRANCH		2    /* taken branch trap */

#endif	/* _MACH_PARISC_EXCEPTION_H_ */
