#ifndef _MACH_PARISC_FLICK_MACH4_SSTUB_H_
#define _MACH_PARISC_FLICK_MACH4_SSTUB_H_

#include <mach/machine/flick_mach4_glue.h>

/* Before doing anything else, reserve the message registers.  */

/* Special parameters */

register unsigned long _portsnd __asm("r13");   /* A additional port */
register unsigned long _porttype __asm("r14");  /* The additional port type */

/* Send and Receive buffer parameters. Used for arrays. */

register unsigned long _bufsend __asm("r15");   /* Sent array pointer */
register unsigned long _bufscnt __asm("r16");   /* Sent array count */
register unsigned long _bufrecv __asm("r24");   /* Received array pointer */
register unsigned long _bufrcnt __asm("r23");   /* Received array pointer */

/* General parameters. */

register unsigned long _param0 __asm("r5");
register unsigned long _param1 __asm("r6");
register unsigned long _param2 __asm("r7");
register unsigned long _param3 __asm("r8");
register unsigned long _param4 __asm("r9");
register unsigned long _param5 __asm("r10");
register unsigned long _param6 __asm("r11");
register unsigned long _param7 __asm("r12");

#define mom_mach4_return(a)	return (rv)


/* Really not a pointer at all - actually the name of a send right.  */
typedef void *mom_object_ref;
#define mom_object_null ((mom_object_ref)0)


typedef struct flick_server
{
	void (*c_entrypoint)();
	void (*entrypoint)();
	int buf_size;
} flick_server;

#define flick_alloc_mach4(a) (void *) malloc((a))

#define flick_free_mach4(a) free((a))

#define flick_mach4_encode_char(a) \
        (char *) (a) = _sendbuffer + _senditer, senditer++

#define flick_mach4_decode_char(a) \
        (a) = ((char *)_recvbuffer)[_recviter], recviter++

#define flick_mach4_encode_int(a) \
        (char *) (a) = _sendbuffer + _senditer, _senditer+=sizeof(int)

#define flick_mach4_decode_int(a) \
        memcpy((char *)&(a),&((char *)_recvbuffer)[_recviter],sizeof(int)), \
        _recviter+=sizeof(int)

#define flick_mach4_encode_one_block(a,s) \
        (char *) (a) = _sendbuffer, _senditer = (s)

#define flick_mach4_encode_block(a,s) \
        (char *) (a) = _sendbuffer+_senditer, _senditer += (s)

#define flick_mach4_decode_block(a,s) \
        (char *) (a) = _recvbuffer+_recviter, _recviter += (s)

#define flick_mach4_decode_one_block(a,s) \
        (char *) (a) = _recvbuffer, _recviter = (s)

#endif _MACH_PARISC_FLICK_MACH4_SSTUB_H_
