/* 
 * Copyright (c) 1990,1991,1992,1993,1994 The University of Utah and
 * the Computer Systems Laboratory (CSL).  All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software is hereby
 * granted provided that (1) source code retains these copyright, permission,
 * and disclaimer notices, and (2) redistributions including binaries
 * reproduce the notices in supporting documentation, and (3) all advertising
 * materials mentioning features or use of this software display the following
 * acknowledgement: ``This product includes software developed by the
 * Computer Systems Laboratory at the University of Utah.''
 *
 * THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
 * IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 *
 * 	Utah $Hdr: thread.h 1.19 94/12/14$
 */

/*
 *      This file defines machine specific, thread related structures,
 *      variables and macros.
 */

#ifndef	_PARISC_THREAD_H_
#define _PARISC_THREAD_H_

#include <mach/kern_return.h>

/*
 * Per-thread kernel stack size
 */
#define KERNEL_STACK_SIZE	(2 * PARISC_PGBYTES)

/*
 * Machine-dependent per-thread information
 */
struct MachineThread
{
	/* page fault recovery (copyin/out)
	   XXX use auto-pc-sense instead */
	vm_offset_t recover;
};
typedef struct MachineThread MachineThread;


/*
 * Kernel state structure
 *
 * This holds the kernel state that is saved and restored across context
 * switches.
 * The kernel_sp in inactive threads points to it.
 */

struct parisc_kernel_state
{
	unsigned r2;		/* Return pointer */
	unsigned r3;		/* Callee save general registers */
	unsigned r4;
	unsigned r5;
	unsigned r6;
	unsigned r7;
	unsigned r8;
	unsigned r9;
	unsigned r10;
	unsigned r11;
	unsigned r12;
	unsigned r13;
	unsigned r14;
	unsigned r15;
	unsigned r16;
	unsigned r17;
	unsigned r18;
	unsigned pad;
};


#include <kern/thread.h>

#endif	/* _PARISC_THREAD_H_ */
