/*
 *  (c) Copyright 1987 HEWLETT-PACKARD COMPANY
 *
 *  To anyone who acknowledges that this file is provided "AS IS"
 *  without any express or implied warranty:
 *      permission to use, copy, modify, and distribute this file
 *  for any purpose is hereby granted without fee, provided that
 *  the above copyright notice and this notice appears in all
 *  copies, and that the name of Hewlett-Packard Company not be
 *  used in advertising or publicity pertaining to distribution
 *  of the software without specific, written prior permission.
 *  Hewlett-Packard Company makes no representations about the
 *  suitability of this software for any purpose.
 */

/* UNISRC_ID	@(#)27.3   87/02/19  */
/* HPUX_ID: @(#)scnhdr.h	27.3     85/10/25 */

/******************************************************************************/
/*                                                                            */
/*     The subspace dictionary consists of a sequence of subspace records     */
/*                                                                            */
/******************************************************************************/

struct subspace_dictionary_record {
        int             space_index;
        unsigned int    access_control_bits: 7; /* access for PDIR entries    */
        unsigned int    memory_resident    : 1; /* lock in memory during 
                                                   execution                  */
        unsigned int    dup_common         : 1; /* data name clashes allowed  */
        unsigned int    is_common          : 1; /* subspace is a common block */
        unsigned int    is_loadable        : 1;
        unsigned int    quadrant	   : 2; /* quadrant request           */
        unsigned int    initially_frozen   : 1; /* must be locked into memory 
                                                   when OS is booted          */
        unsigned int    is_first   	   : 1; /* must be first subspace     */
        unsigned int    code_only   	   : 1; /* must contain only code     */
        unsigned int    sort_key           : 8;
        unsigned int    reserved           : 8;
        int             file_loc_init_value;    /* file location or 
                                                   initialization value       */
        unsigned int    initialization_length;
        unsigned int    subspace_start;         /* starting offset            */
        unsigned int    subspace_length;        /* number of bytes defined 
                                                   by this subspace           */
        unsigned int    reserved2	   :16;   
        unsigned int    alignment	   :16; /* alignment required for the
                                                   subspace (largest alignment 
                                                   requested for any item in 
                                                   the subspace)              */
        union name_pt   name;                   /* index of subspace name     */
        int             fixup_request_index;    /* index into fixup array     */
        unsigned int    fixup_request_quantity; /* number of fixup requests   */
};

#define	SCNHDR	struct subspace_dictionary_record
#define	SCNHSZ	sizeof(SCNHDR)

/*
 * Define constants for names of "special" subspaces
 */

#define _TEXT "$TEXT$"
#define _DATA "$DATA$"
#define _BSS  "$BSS$"
