/* 
 * Copyright (c) 1991,1994 The University of Utah and
 * the Computer Systems Laboratory at the University of Utah (CSL).
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software is hereby
 * granted provided that (1) source code retains these copyright, permission,
 * and disclaimer notices, and (2) redistributions including binaries
 * reproduce the notices in supporting documentation, and (3) all advertising
 * materials mentioning features or use of this software display the following
 * acknowledgement: ``This product includes software developed by the
 * Computer Systems Laboratory at the University of Utah.''
 *
 * THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
 * IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 *
 * 	Utah $Hdr: lan_kgdb.h 1.3 94/12/14$
 *	Author: Bob Wheeler, University of Utah CSL
 */

/*
 *	Structures for LAN interface to kgdb
 */

struct kdgb_packet {
	u_char dest[6];
	u_char source[6];
	u_short ether_type;
	u_short pad;

	int packet_id;
	int success;

	u_int command;
	u_int address;
	u_int length;
	
	u_char data[ETHERMTU-36];
}


/*
 * command types
 */
#define KGDB_READ_REGISTERS	1
#define KGDB_WRITE_REGISTERS	2
#define KGDB_READ_MEMORY	3
#define KGDB_WRITE_MEMORY	4
#define KGDB_CONTINUE		5
#define KGDB_STEP		6
#define KGDB_LAST_SIGNAL	7
#define KGDB_KILL		8
